﻿/* 
This file is part of Ingo Karstein's Web based PowerShell Console project

**Do not remove this comment**

Please see the project homepage at CodePlex:
  http://webpsconsole.codeplex.com/

Please see my blog:
  http://ikarstein.wordpress.com

Licence: GPLv2
    Ingo Karstein's SharePoint 2010 Custom Ribbon Demo
    Copyright (C) 2011  Ingo Karstein, ikarstein@hotmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ik.PowerShell.WebPSConsole
{
    internal static class Statics
    {
        public static Server Server;
        public static int SessionTimeout = 20;
        public static int SessionTimeoutWarning = 15;
        public static TimeSpan SessionTimeoutSpan = new TimeSpan(0, Statics.SessionTimeout, 0);
    }

    public class ReadKeyResponse
    {
        public int keyCode;
        public int which;
        public char key;
        public bool? ctrlKey;
        public bool? altKey;
        public bool? shiftKey;
        public bool? metaKey;
        public bool cancel;
    }

    public class ChoiceResponse
    {
        public int choice;
        public bool cancel;
    }

    public class CredentialResponse
    {
        public string usr;
        public string pwd;
        public bool cancel;
    }

    public class SecureStringResponse
    {
        public bool cancel;
        public string secstr;
    }

    public class LineinputResponse
    {
        public bool cancel;
        public string input;
    }

    public class CommandResponse
    {
        public string data;
    }
}